<?php

declare(strict_types=1);

namespace App\Http\Requests\Category;

use App\Http\Requests\InvalidDataResponseTrait;
use App\Http\Resources\CategoryResource;
use Illuminate\Foundation\Http\FormRequest;

class StoreCategoryRequest extends FormRequest
{
    use InvalidDataResponseTrait;

    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, string>
     */
    public function rules(): array
    {
        return static::rulesDefinition();
    }

    /**
     * @return array<string, string>
     */
    public static function rulesDefinition(): array
    {
        return [
            'name' => 'required|string',
        ];
    }

    public function getCategory(): CategoryResource
    {
        return CategoryResource::make($this->all());
    }
}
