<?php

declare(strict_types=1);

namespace App\Http\Requests\Post;

use App\Http\Requests\InvalidDataResponseTrait;
use Illuminate\Foundation\Http\FormRequest;

class UpdatePostRequest extends FormRequest
{
    use InvalidDataResponseTrait;

    /**
     * @return array<string, string>
     */
    public function all($keys = null): array
    {
        $request = parent::all($keys);

        $request['id'] = $this->route('id');

        return $request;
    }


    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, string>
     */
    public function rules(): array
    {
        return [
            ...StorePostRequest::rulesDefinition(),
            'id' => 'required|integer|min:0',
        ];
    }
}
