<?php

declare(strict_types=1);

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use L5Swagger\L5SwaggerServiceProvider;
use OpenApi\Annotations as OA;

/**
 * @OA\Info(
 *     title="Post API",
 *     version="1.0.0",
 * )
 */
class SwaggerProvider extends ServiceProvider
{
    public function register()
    {
        $this->app->register(L5SwaggerServiceProvider::class);
    }

    /**
     * Bootstrap services.
     */
    public function boot(): void
    {
        //
    }
}
