<?php

declare(strict_types=1);

namespace App\Services\QueryRequestModifiers\Category;

use App\Http\Requests\Category\ListCategoryRequest;
use App\Models\Category;
use App\Services\QueryRequestModifiers\Orderable;
use Illuminate\Database\Eloquent\Builder;

class CategoryOrder
{
    /**
     * @use Orderable<Category, CategoryOrderDTO>
     */
    use Orderable;


    /**
     * @param Builder<Category> $query
     * @return Builder<Category>
     */
    public function apply(Builder $query, ?CategoryOrderDTO $filters): Builder
    {
        return $this->applyOrderable($query, $filters);
    }

    public function makeFromRequest(ListCategoryRequest $request): ?CategoryOrderDTO
    {
        return $this->makeOrderableFromRequest($request, CategoryOrderDTO::class);
    }
}
