<?php

declare(strict_types=1);

namespace App\Services\QueryRequestModifiers\Comment;

use App\Http\Requests\Comment\ListCommentRequest;
use App\Models\Comment;
use App\Services\QueryRequestModifiers\Orderable;
use Illuminate\Database\Eloquent\Builder;

class CommentOrder
{
    /**
     * @use Orderable<Comment, CommentOrderDTO>
     */
    use Orderable;


    /**
     * @param Builder<Comment> $query
     * @return Builder<Comment>
     */
    public function apply(Builder $query, ?CommentOrderDTO $filters): Builder
    {
        return $this->applyOrderable($query, $filters);
    }

    public function makeFromRequest(ListCommentRequest $request): ?CommentOrderDTO
    {
        return $this->makeOrderableFromRequest($request, CommentOrderDTO::class);
    }
}
