<?php

declare(strict_types=1);

namespace App\Services\QueryRequestModifiers\Post;

use App\Services\CacheKeyInterface;

readonly class PostFilterDTO implements CacheKeyInterface
{
    /**
     * @param array<string, string> $filters
     */
    public function __construct(public array $filters)
    {
    }

    public function toCacheKey(): string
    {
        return http_build_query($this->filters, '', '|');
    }
}
