#!/usr/bin/env sh

set -ex


docker compose build

# composer
docker compose run --rm -it php-fpm composer install

docker compose run --rm -it php-fpm /bin/bash -c 'mkdir -p /var/www/html/storage && mkdir -p /var/www/html/storage/{logs,app,api-docs,framework,framework/cache,framework/sessions,framework/testing,framework/views,app/private,app/public}'

# database
docker compose run --rm -it php-fpm /var/www/html/artisan migrate

# fix permissions (TODO: fix-me) - by user in dockerfile
docker compose run --rm -it php-fpm /bin/sh -c "chown -R www-data:www-data /var/www/html/storage && find /var/www/html/storage -type d -exec chmod 775 '{}' ';' && if [ -d /var/www/html/bootstrap/cache ]; then find /var/www/html/bootstrap/cache -not -name '.gitignore' -exec chmod 777 '{}' ';'; fi"


docker compose run --rm -it php-fpm /var/www/html/artisan l5-swagger:generate

# run containers (and build again)
if [ "$NO_EXECUTE" != "1" ]; then
  docker compose up --build
fi

